#-*- coding:utf-8 -*-

#    Pybik -- A 3 dimensional magic cube game.
#    Copyright (C) 2009        B. Clausius
#    Copyright (C) 2003, 2004  John Darrington
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 3 of the License,  or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.


import gtk
import gobject

import cube
import glarea
import config
import ui
import widget_set
import move_queue_m


N_ = lambda string: string


gtk_main_quit = gtk.main_quit

#TODO nach ui verschieben?
def new_game (new_size, application):
    if ui.is_animating ():
        return True

    if new_size > 0:
        glarea.re_initialize_glarea ()

        # create the cube
        if new_size <= 0:
            new_size = cube.get_cube_dimension()
        cube.set_cube_dimension(new_size)

    cube.cube_randomize()
    glarea.postRedisplay ()
    ui.move_queue = move_queue_m.MoveQueue()
    #widget_set.set_toolbar_state (0)
    ui.update_ui(application)

    return False


class PreferencesDialog (object):
    def __init__(self, application):
        dialog = application.get_object('dialog_preferences')

        self.new_dim = cube.get_cube_dimension()
        self.new_values = False
        self.new_frameQty = 0
        self.application = application
        
        entry = application.get_object('button_size')
        entry.set_value(cube.get_cube_dimension())
        entry.connect ("changed", self.on_size_changed)

        entry = application.get_object('hscale_animspeed')
        entry.set_value(ui.frameQty)
        entry.connect ("value-changed", self.on_hscale_animspeed_value_changed)

        button_lighting = application.get_object('button_lighting')
        button_lighting.set_active (glarea.get_lighting())
        button_lighting.connect ("toggled", self.on_set_lighting)

        response = dialog.run ()
        self.confirm_preferences ()
        #dialog.destroy ()
        dialog.hide()

    def on_yesnoresp (self, dialog, resp):
        if resp == gtk.RESPONSE_YES:
            self.application.request_new_game (None,  self.new_dim)
        
        dialog.destroy ()

    # Close the preferences window,  and update all the necessary values
    def confirm_preferences (self):
        if self.new_values:
            ui.frameQty = self.new_frameQty

        if self.new_dim != cube.get_cube_dimension():
            dialog = gtk.MessageDialog (widget_set.main_application_window,
                         gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT,
                         gtk.MESSAGE_QUESTION, gtk.BUTTONS_YES_NO,
                         _("The Dimension of the cube has changed.\nStart cube with new settings?"))
            dialog.connect ("response", self.on_yesnoresp)
            dialog.show_all ()

    def on_size_changed (self, editable):
        str_ = editable.get_chars (0, -1)
        self.new_dim = int(str_)

    def on_hscale_animspeed_value_changed (self, widget):
        self.new_values = True
        self.new_frameQty = widget.get_value()

    def on_set_lighting (self, toggle_button):
        glarea.set_lighting(toggle_button.get_active())


if DEBUG:
    # Manually make a move on the cube
    def on_manual_move (unused_w, data, application):
        # Just loose the first argument and call the next function
        ui.request_rotation (data, application)
        glarea.postRedisplay ()



def about (unused_w, toplevel):
    dialog = gtk.AboutDialog ()
    dialog.set_modal (True)
    dialog.set_transient_for (toplevel)

    dialog.set_copyright (config.copyleft_notice)

    dialog.run ()
    dialog.destroy ()

