#!/usr/bin/python
#-*- coding:utf-8 -*-

#    Pybik -- A 3 dimensional magic cube game.
#    Copyright (C) 2009  B. Clausius
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.


try:
    import python_traceback
    python_traceback.install_dbus()
except:
    pass


import sys, os

source_dir = os.path.dirname(os.path.realpath(__file__))
root_dir, sub_dir = os.path.split(source_dir)


PACKAGE = 'pybik'
#FIXME
if sub_dir == 'pybiklib':
    LOCALEDIR = root_dir
else:
    LOCALEDIR = '/usr/local/share/locale'

try:
    import gettext
    gettext.install(PACKAGE, LOCALEDIR, names=['ngettext'])
except:
    __builtins__._ = lambda x: x
    __builtins__.ngettext = lambda s,p,n: (s if n == 1 else p)


try:
    if sub_dir == 'pybiklib':
        sys.path.insert(0, root_dir)
        print _('Running from source directory')
        import pybiklib
    from pybiklib import main
except ImportError:
    print _('%s is not properly installed.') % PACKAGE
    raise


opt_vals = main.app_opts (sys.argv[1:], frameQty=2, solved=False, cube_dimension=3,
                                pure_python=False, debug_level=0)
debug_level = opt_vals['debug_level']
__builtins__.debug = lambda x: x
if debug_level >= 1:
    try:
        import decoratorsX
        __builtins__.debug = decoratorsX.debug
    except:
        pass
__builtins__.DEBUG = (debug_level >= 2)
main.import_(opt_vals['pure_python'])

from pybiklib import config

if sub_dir == 'pybiklib':
    config.path.resourcedir = os.path.join(source_dir, '../data')
    config.path.pixmapdir = config.path.resourcedir
    config.path.plugindir = config.path.resourcedir
else:
    config.path.resourcedir = '/usr/local/share/pybik'
    config.path.pixmapdir = '/usr/local/share/pixmaps'
    config.path.plugindir = config.path.resourcedir


if __name__ == '__main__':
    main.run(sys.argv, opt_vals['frameQty'], opt_vals['cube_dimension'], opt_vals['solved'])

